Merge branch 'bc/hash-algo'
[git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_STUCKLONG=t
9 OPTIONS_SPEC="\
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
11 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
12 git rebase --continue | --abort | --skip | --edit-todo
13 --
14  Available options are
15 v,verbose!         display a diffstat of what changed upstream
16 q,quiet!           be quiet. implies --no-stat
17 autostash          automatically stash/stash pop before and after
18 fork-point         use 'merge-base --fork-point' to refine upstream
19 onto=!             rebase onto given branch instead of upstream
20 p,preserve-merges! try to recreate merges instead of ignoring them
21 s,strategy=!       use the given merge strategy
22 no-ff!             cherry-pick all commits, even if unchanged
23 m,merge!           use merging strategies to rebase
24 i,interactive!     let the user edit the list of commits to rebase
25 x,exec=!           add exec lines after each commit of the editable list
26 k,keep-empty       preserve empty commits during rebase
27 f,force-rebase!    force rebase even if branch is up to date
28 X,strategy-option=! pass the argument through to the merge strategy
29 stat!              display a diffstat of what changed upstream
30 n,no-stat!         do not show diffstat of what changed upstream
31 verify             allow pre-rebase hook to run
32 rerere-autoupdate  allow rerere to update index with resolved conflicts
33 root!              rebase all reachable commits up to the root(s)
34 autosquash         move commits that begin with squash!/fixup! under -i
35 committer-date-is-author-date! passed to 'git am'
36 ignore-date!       passed to 'git am'
37 signoff            passed to 'git am'
38 whitespace=!       passed to 'git apply'
39 ignore-whitespace! passed to 'git apply'
40 C=!                passed to 'git apply'
41 S,gpg-sign?        GPG-sign commits
42  Actions:
43 continue!          continue
44 abort!             abort and check out the original branch
45 skip!              skip current patch and continue
46 edit-todo!         edit the todo list during an interactive rebase
47 quit!              abort but keep HEAD where it is
48 "
49 . git-sh-setup
50 set_reflog_action rebase
51 require_work_tree_exists
52 cd_to_toplevel
53
54 LF='
55 '
56 ok_to_skip_pre_rebase=
57 resolvemsg="
58 $(gettext 'Resolve all conflicts manually, mark them as resolved with
59 "git add/rm <conflicted_files>", then run "git rebase --continue".
60 You can instead skip this commit: run "git rebase --skip".
61 To abort and get back to the state before "git rebase", run "git rebase --abort".')
62 "
63 unset onto
64 unset restrict_revision
65 cmd=
66 strategy=
67 strategy_opts=
68 do_merge=
69 merge_dir="$GIT_DIR"/rebase-merge
70 apply_dir="$GIT_DIR"/rebase-apply
71 verbose=
72 diffstat=
73 test "$(git config --bool rebase.stat)" = true && diffstat=t
74 autostash="$(git config --bool rebase.autostash || echo false)"
75 fork_point=auto
76 git_am_opt=
77 git_format_patch_opt=
78 rebase_root=
79 force_rebase=
80 allow_rerere_autoupdate=
81 # Non-empty if a rebase was in progress when 'git rebase' was invoked
82 in_progress=
83 # One of {am, merge, interactive}
84 type=
85 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
86 state_dir=
87 # One of {'', continue, skip, abort}, as parsed from command line
88 action=
89 preserve_merges=
90 autosquash=
91 keep_empty=
92 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
93 case "$(git config --bool commit.gpgsign)" in
94 true)   gpg_sign_opt=-S ;;
95 *)      gpg_sign_opt= ;;
96 esac
97
98 read_basic_state () {
99         test -f "$state_dir/head-name" &&
100         test -f "$state_dir/onto" &&
101         head_name=$(cat "$state_dir"/head-name) &&
102         onto=$(cat "$state_dir"/onto) &&
103         # We always write to orig-head, but interactive rebase used to write to
104         # head. Fall back to reading from head to cover for the case that the
105         # user upgraded git with an ongoing interactive rebase.
106         if test -f "$state_dir"/orig-head
107         then
108                 orig_head=$(cat "$state_dir"/orig-head)
109         else
110                 orig_head=$(cat "$state_dir"/head)
111         fi &&
112         GIT_QUIET=$(cat "$state_dir"/quiet) &&
113         test -f "$state_dir"/verbose && verbose=t
114         test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
115         test -f "$state_dir"/strategy_opts &&
116                 strategy_opts="$(cat "$state_dir"/strategy_opts)"
117         test -f "$state_dir"/allow_rerere_autoupdate &&
118                 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
119         test -f "$state_dir"/gpg_sign_opt &&
120                 gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
121 }
122
123 write_basic_state () {
124         echo "$head_name" > "$state_dir"/head-name &&
125         echo "$onto" > "$state_dir"/onto &&
126         echo "$orig_head" > "$state_dir"/orig-head &&
127         echo "$GIT_QUIET" > "$state_dir"/quiet &&
128         test t = "$verbose" && : > "$state_dir"/verbose
129         test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
130         test -n "$strategy_opts" && echo "$strategy_opts" > \
131                 "$state_dir"/strategy_opts
132         test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
133                 "$state_dir"/allow_rerere_autoupdate
134         test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
135 }
136
137 output () {
138         case "$verbose" in
139         '')
140                 output=$("$@" 2>&1 )
141                 status=$?
142                 test $status != 0 && printf "%s\n" "$output"
143                 return $status
144                 ;;
145         *)
146                 "$@"
147                 ;;
148         esac
149 }
150
151 move_to_original_branch () {
152         case "$head_name" in
153         refs/*)
154                 message="rebase finished: $head_name onto $onto"
155                 git update-ref -m "$message" \
156                         $head_name $(git rev-parse HEAD) $orig_head &&
157                 git symbolic-ref \
158                         -m "rebase finished: returning to $head_name" \
159                         HEAD $head_name ||
160                 die "$(eval_gettext "Could not move back to \$head_name")"
161                 ;;
162         esac
163 }
164
165 apply_autostash () {
166         if test -f "$state_dir/autostash"
167         then
168                 stash_sha1=$(cat "$state_dir/autostash")
169                 if git stash apply $stash_sha1 >/dev/null 2>&1
170                 then
171                         echo "$(gettext 'Applied autostash.')" >&2
172                 else
173                         git stash store -m "autostash" -q $stash_sha1 ||
174                         die "$(eval_gettext "Cannot store \$stash_sha1")"
175                         gettext 'Applying autostash resulted in conflicts.
176 Your changes are safe in the stash.
177 You can run "git stash pop" or "git stash drop" at any time.
178 ' >&2
179                 fi
180         fi
181 }
182
183 finish_rebase () {
184         apply_autostash &&
185         { git gc --auto || true; } &&
186         rm -rf "$state_dir"
187 }
188
189 run_specific_rebase () {
190         if [ "$interactive_rebase" = implied ]; then
191                 GIT_EDITOR=:
192                 export GIT_EDITOR
193                 autosquash=
194         fi
195         . git-rebase--$type
196         ret=$?
197         if test $ret -eq 0
198         then
199                 finish_rebase
200         elif test $ret -eq 2 # special exit status for rebase -i
201         then
202                 apply_autostash &&
203                 rm -rf "$state_dir" &&
204                 die "Nothing to do"
205         fi
206         exit $ret
207 }
208
209 run_pre_rebase_hook () {
210         if test -z "$ok_to_skip_pre_rebase" &&
211            test -x "$(git rev-parse --git-path hooks/pre-rebase)"
212         then
213                 "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
214                 die "$(gettext "The pre-rebase hook refused to rebase.")"
215         fi
216 }
217
218 test -f "$apply_dir"/applying &&
219         die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
220
221 if test -d "$apply_dir"
222 then
223         type=am
224         state_dir="$apply_dir"
225 elif test -d "$merge_dir"
226 then
227         if test -f "$merge_dir"/interactive
228         then
229                 type=interactive
230                 interactive_rebase=explicit
231         else
232                 type=merge
233         fi
234         state_dir="$merge_dir"
235 fi
236 test -n "$type" && in_progress=t
237
238 total_argc=$#
239 while test $# != 0
240 do
241         case "$1" in
242         --no-verify)
243                 ok_to_skip_pre_rebase=yes
244                 ;;
245         --verify)
246                 ok_to_skip_pre_rebase=
247                 ;;
248         --continue|--skip|--abort|--quit|--edit-todo)
249                 test $total_argc -eq 2 || usage
250                 action=${1##--}
251                 ;;
252         --onto=*)
253                 onto="${1#--onto=}"
254                 ;;
255         --exec=*)
256                 cmd="${cmd}exec ${1#--exec=}${LF}"
257                 test -z "$interactive_rebase" && interactive_rebase=implied
258                 ;;
259         --interactive)
260                 interactive_rebase=explicit
261                 ;;
262         --keep-empty)
263                 keep_empty=yes
264                 ;;
265         --preserve-merges)
266                 preserve_merges=t
267                 test -z "$interactive_rebase" && interactive_rebase=implied
268                 ;;
269         --autosquash)
270                 autosquash=t
271                 ;;
272         --no-autosquash)
273                 autosquash=
274                 ;;
275         --fork-point)
276                 fork_point=t
277                 ;;
278         --no-fork-point)
279                 fork_point=
280                 ;;
281         --merge)
282                 do_merge=t
283                 ;;
284         --strategy-option=*)
285                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
286                 do_merge=t
287                 test -z "$strategy" && strategy=recursive
288                 ;;
289         --strategy=*)
290                 strategy="${1#--strategy=}"
291                 do_merge=t
292                 ;;
293         --no-stat)
294                 diffstat=
295                 ;;
296         --stat)
297                 diffstat=t
298                 ;;
299         --autostash)
300                 autostash=true
301                 ;;
302         --no-autostash)
303                 autostash=false
304                 ;;
305         --verbose)
306                 verbose=t
307                 diffstat=t
308                 GIT_QUIET=
309                 ;;
310         --quiet)
311                 GIT_QUIET=t
312                 git_am_opt="$git_am_opt -q"
313                 verbose=
314                 diffstat=
315                 ;;
316         --whitespace=*)
317                 git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
318                 case "${1#--whitespace=}" in
319                 fix|strip)
320                         force_rebase=t
321                         ;;
322                 esac
323                 ;;
324         --ignore-whitespace)
325                 git_am_opt="$git_am_opt $1"
326                 ;;
327         --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
328                 git_am_opt="$git_am_opt $1"
329                 force_rebase=t
330                 ;;
331         -C*)
332                 git_am_opt="$git_am_opt $1"
333                 ;;
334         --root)
335                 rebase_root=t
336                 ;;
337         --force-rebase|--no-ff)
338                 force_rebase=t
339                 ;;
340         --rerere-autoupdate|--no-rerere-autoupdate)
341                 allow_rerere_autoupdate="$1"
342                 ;;
343         --gpg-sign)
344                 gpg_sign_opt=-S
345                 ;;
346         --gpg-sign=*)
347                 gpg_sign_opt="-S${1#--gpg-sign=}"
348                 ;;
349         --)
350                 shift
351                 break
352                 ;;
353         *)
354                 usage
355                 ;;
356         esac
357         shift
358 done
359 test $# -gt 2 && usage
360
361 if test -n "$action"
362 then
363         test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
364         # Only interactive rebase uses detailed reflog messages
365         if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
366         then
367                 GIT_REFLOG_ACTION="rebase -i ($action)"
368                 export GIT_REFLOG_ACTION
369         fi
370 fi
371
372 if test "$action" = "edit-todo" && test "$type" != "interactive"
373 then
374         die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
375 fi
376
377 case "$action" in
378 continue)
379         # Sanity check
380         git rev-parse --verify HEAD >/dev/null ||
381                 die "$(gettext "Cannot read HEAD")"
382         git update-index --ignore-submodules --refresh &&
383         git diff-files --quiet --ignore-submodules || {
384                 echo "$(gettext "You must edit all merge conflicts and then
385 mark them as resolved using git add")"
386                 exit 1
387         }
388         read_basic_state
389         run_specific_rebase
390         ;;
391 skip)
392         output git reset --hard HEAD || exit $?
393         read_basic_state
394         run_specific_rebase
395         ;;
396 abort)
397         git rerere clear
398         read_basic_state
399         case "$head_name" in
400         refs/*)
401                 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
402                 die "$(eval_gettext "Could not move back to \$head_name")"
403                 ;;
404         esac
405         output git reset --hard $orig_head
406         finish_rebase
407         exit
408         ;;
409 quit)
410         exec rm -rf "$state_dir"
411         ;;
412 edit-todo)
413         run_specific_rebase
414         ;;
415 esac
416
417 # Make sure no rebase is in progress
418 if test -n "$in_progress"
419 then
420         state_dir_base=${state_dir##*/}
421         cmd_live_rebase="git rebase (--continue | --abort | --skip)"
422         cmd_clear_stale_rebase="rm -fr \"$state_dir\""
423         die "
424 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
425 I wonder if you are in the middle of another rebase.  If that is the
426 case, please try
427         $cmd_live_rebase
428 If that is not the case, please
429         $cmd_clear_stale_rebase
430 and run me again.  I am stopping in case you still have something
431 valuable there.')"
432 fi
433
434 if test -n "$rebase_root" && test -z "$onto"
435 then
436         test -z "$interactive_rebase" && interactive_rebase=implied
437 fi
438
439 if test -n "$interactive_rebase"
440 then
441         type=interactive
442         state_dir="$merge_dir"
443 elif test -n "$do_merge"
444 then
445         type=merge
446         state_dir="$merge_dir"
447 else
448         type=am
449         state_dir="$apply_dir"
450 fi
451
452 if test -t 2 && test -z "$GIT_QUIET"
453 then
454         git_format_patch_opt="$git_format_patch_opt --progress"
455 fi
456
457 if test -z "$rebase_root"
458 then
459         case "$#" in
460         0)
461                 if ! upstream_name=$(git rev-parse --symbolic-full-name \
462                         --verify -q @{upstream} 2>/dev/null)
463                 then
464                         . git-parse-remote
465                         error_on_missing_default_upstream "rebase" "rebase" \
466                                 "against" "git rebase $(gettext '<branch>')"
467                 fi
468
469                 test "$fork_point" = auto && fork_point=t
470                 ;;
471         *)      upstream_name="$1"
472                 if test "$upstream_name" = "-"
473                 then
474                         upstream_name="@{-1}"
475                 fi
476                 shift
477                 ;;
478         esac
479         upstream=$(peel_committish "${upstream_name}") ||
480         die "$(eval_gettext "invalid upstream '\$upstream_name'")"
481         upstream_arg="$upstream_name"
482 else
483         if test -z "$onto"
484         then
485                 empty_tree=$(git hash-object -t tree /dev/null)
486                 onto=$(git commit-tree $empty_tree </dev/null)
487                 squash_onto="$onto"
488         fi
489         unset upstream_name
490         unset upstream
491         test $# -gt 1 && usage
492         upstream_arg=--root
493 fi
494
495 # Make sure the branch to rebase onto is valid.
496 onto_name=${onto-"$upstream_name"}
497 case "$onto_name" in
498 *...*)
499         if      left=${onto_name%...*} right=${onto_name#*...} &&
500                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
501         then
502                 case "$onto" in
503                 ?*"$LF"?*)
504                         die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
505                         ;;
506                 '')
507                         die "$(eval_gettext "\$onto_name: there is no merge base")"
508                         ;;
509                 esac
510         else
511                 die "$(eval_gettext "\$onto_name: there is no merge base")"
512         fi
513         ;;
514 *)
515         onto=$(peel_committish "$onto_name") ||
516         die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
517         ;;
518 esac
519
520 # If the branch to rebase is given, that is the branch we will rebase
521 # $branch_name -- branch/commit being rebased, or HEAD (already detached)
522 # $orig_head -- commit object name of tip of the branch before rebasing
523 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
524 switch_to=
525 case "$#" in
526 1)
527         # Is it "rebase other $branchname" or "rebase other $commit"?
528         branch_name="$1"
529         switch_to="$1"
530
531         # Is it a local branch?
532         if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
533            orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
534         then
535                 head_name="refs/heads/$branch_name"
536         # If not is it a valid ref (branch or commit)?
537         elif orig_head=$(git rev-parse -q --verify "$branch_name")
538         then
539                 head_name="detached HEAD"
540
541         else
542                 die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
543         fi
544         ;;
545 0)
546         # Do not need to switch branches, we are already on it.
547         if branch_name=$(git symbolic-ref -q HEAD)
548         then
549                 head_name=$branch_name
550                 branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
551         else
552                 head_name="detached HEAD"
553                 branch_name=HEAD
554         fi
555         orig_head=$(git rev-parse --verify HEAD) || exit
556         ;;
557 *)
558         die "BUG: unexpected number of arguments left to parse"
559         ;;
560 esac
561
562 if test "$fork_point" = t
563 then
564         new_upstream=$(git merge-base --fork-point "$upstream_name" \
565                         "${switch_to:-HEAD}")
566         if test -n "$new_upstream"
567         then
568                 restrict_revision=$new_upstream
569         fi
570 fi
571
572 if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
573 then
574         stash_sha1=$(git stash create "autostash") ||
575         die "$(gettext 'Cannot autostash')"
576
577         mkdir -p "$state_dir" &&
578         echo $stash_sha1 >"$state_dir/autostash" &&
579         stash_abbrev=$(git rev-parse --short $stash_sha1) &&
580         echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
581         git reset --hard
582 fi
583
584 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
585
586 # Now we are rebasing commits $upstream..$orig_head (or with --root,
587 # everything leading up to $orig_head) on top of $onto
588
589 # Check if we are already based on $onto with linear history,
590 # but this should be done only when upstream and onto are the same
591 # and if this is not an interactive rebase.
592 mb=$(git merge-base "$onto" "$orig_head")
593 if test "$type" != interactive && test "$upstream" = "$onto" &&
594         test "$mb" = "$onto" && test -z "$restrict_revision" &&
595         # linear history?
596         ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
597 then
598         if test -z "$force_rebase"
599         then
600                 # Lazily switch to the target branch if needed...
601                 test -z "$switch_to" ||
602                 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
603                         git checkout -q "$switch_to" --
604                 if test "$branch_name" = "HEAD" &&
605                          ! git symbolic-ref -q HEAD
606                 then
607                         say "$(eval_gettext "HEAD is up to date.")"
608                 else
609                         say "$(eval_gettext "Current branch \$branch_name is up to date.")"
610                 fi
611                 finish_rebase
612                 exit 0
613         else
614                 if test "$branch_name" = "HEAD" &&
615                          ! git symbolic-ref -q HEAD
616                 then
617                         say "$(eval_gettext "HEAD is up to date, rebase forced.")"
618                 else
619                         say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
620                 fi
621         fi
622 fi
623
624 # If a hook exists, give it a chance to interrupt
625 run_pre_rebase_hook "$upstream_arg" "$@"
626
627 if test -n "$diffstat"
628 then
629         if test -n "$verbose"
630         then
631                 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
632         fi
633         # We want color (if set), but no pager
634         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
635 fi
636
637 test "$type" = interactive && run_specific_rebase
638
639 # Detach HEAD and reset the tree
640 say "$(gettext "First, rewinding head to replay your work on top of it...")"
641
642 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
643         git checkout -q "$onto^0" || die "could not detach HEAD"
644 git update-ref ORIG_HEAD $orig_head
645
646 # If the $onto is a proper descendant of the tip of the branch, then
647 # we just fast-forwarded.
648 if test "$mb" = "$orig_head"
649 then
650         say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
651         move_to_original_branch
652         finish_rebase
653         exit 0
654 fi
655
656 if test -n "$rebase_root"
657 then
658         revisions="$onto..$orig_head"
659 else
660         revisions="${restrict_revision-$upstream}..$orig_head"
661 fi
662
663 run_specific_rebase